<template>
  <el-dialog
    v-model="visible"
    :title="title"
    width="700px"
    destroy-on-close
  >
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="80px"
    >
      <el-form-item label="界面名称" prop="uiKey">
        <el-select v-model="formData.uiKey">
          <el-option
            v-for="dict in ti_ui_config"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="上传图片">
        <el-upload
          v-model:file-list="uploadFileList"
          :action="`${data.baseUrl}/system/file/upload`"
          :before-upload="beforeAvatarUpload"
          :data="{fileType:uploadFileType}"
          :headers="{
                'authorization':  getToken()
              }"
          :limit="1"
          :on-error="uploadError"
          :on-success="uploadSuccess"
          class="file-uploader"
          :on-preview="handlePictureCardPreview"
        >
          <el-button type="primary">选取文件</el-button>
          <template #tip>
            <div class="el-upload__tip">
              支持格式：'png', 'jpg', 'jpeg'，大小不超过5MB
            </div>
          </template>
        </el-upload>
      </el-form-item>
      <el-form-item label="描述" prop="remark">
        <el-input
          v-model="formData.remark"
          type="textarea"
          :rows="3"
          placeholder="请输入描述"
        />
      </el-form-item>
    </el-form>
    <FunctionSelection :funcIds="props.formData.funcIds" :selectNode="selectNode" :selectIds="selectIds" @updateSelectRows="getSelectRows" />
    <template #footer>
      <span class="dialog-footer">
        <el-button @click="handleCancel">取消</el-button>
        <el-button type="primary" @click="handleConfirm">确认</el-button>
      </span>
    </template>
  </el-dialog>

  <!-- 手动控制的预览组件，append-to-body 使其挂载到 body 末尾 -->
    <ElImageViewer
      v-if="isViewerOpen"
      :url-list="[currentImage]"
      @close="closeViewer"
      append-to-body
    />
</template>

<script setup>
import { ref, watch } from 'vue'
import { useDict } from '@/utils/dict'
import FunctionSelection from './FunctionSelection.vue'
import { ElMessage, ElImageViewer } from 'element-plus'
import { getToken } from "@/utils/auth.js";
import { supportType } from "@/enum/index.js";

const props = defineProps({
  visible: {
    type: Boolean,
    default: false
  },
  title: {
    type: String,
    default: ''
  },
  formData: {
    type: Object,
    default: () => {}
  },
  selectNode: {
    type: Object,
    default: () => {}
  }
})
const emit = defineEmits(['update:visible', 'confirm'])

const imgUrl = ref('')
const uploadFileList = ref([])
const uploadFileType = ref(null)
const data = {
  baseUrl: import.meta.env.VITE_APP_BASE_API
}

const beforeAvatarUpload = (rawFile) => {
  const fileName = rawFile.name.split('.');
  const fileExt = fileName[fileName.length - 1];
  const isTypeOk = ['png', 'jpg', 'jpeg'].indexOf(fileExt) >= 0;
  if (!isTypeOk) {
    proxy.$modal.msgError(`文件格式不正确，请上传${['png', 'jpg', 'jpeg'].join("/")}格式文件!`);
    return false;
  }
  const {label = undefined, value = undefined} = supportType?.find(item => item.label === rawFile.type)
  if (label) {
    uploadFileType.value = value
  }
  // 校检文件大小
  
  const isLt = rawFile.size / 1024 / 1024 < 5;
  if (!isLt) {
    ElMessage.error(`上传文件大小不能超过 ${5} MB!`);
    return false;
  }
  
  return true
}

const uploadSuccess = (e) => {
  imgUrl.value = e.msg
  ElMessage.success('上传成功')
}
const uploadError = (e) => {
  console.log("uploadError", e)
}

const isViewerOpen = ref(false);
const currentImage = ref('');

const handlePictureCardPreview = (uploadFile) => {
  currentImage.value = uploadFile.response.msg;
  isViewerOpen.value = true;
}

const closeViewer = () => {
  isViewerOpen.value = false;
}

const { ti_ui_config } = useDict("ti_ui_config");

const formRef = ref()

// 表单验证规则
const formRules = {
  uiKey: [
    { required: true, message: '请输入界面名称', trigger: 'blur' }
  ]
}

const visible = ref(props.visible)

watch(() => props.visible, (newVal) => {
  visible.value = newVal
  if (props.formData.uiUrl) {
    imgUrl.value = props.formData.uiUrl
    uploadFileList.value = [{
      name: 'image',
      url: props.formData.uiUrl,
      response: {
        msg: props.formData.uiUrl
      }
    }]
  }
  if (props.formData.funcIds) {
    selectIds.value = props.formData.funcIds.split(',')
  }
})

watch(visible, (newVal) => {
  emit('update:visible', newVal)
})

function handleConfirm() {
  if (selectIds.value.length === 0) {
    ElMessage.warning('请先选择功能')
    return
  }
  if (!formRef.value) return

  formRef.value.validate((valid) => {
  const obj = {
    ...props.formData,
    funcIds: selectIds.value.toString()
  }
  if (imgUrl.value && imgUrl.value.length > 0) {
      obj.uiUrl = imgUrl.value
    }
    emit('confirm', valid, { ...obj })
  })
}

function handleCancel() {
  visible.value = false
}

const selectIds = ref([])
const getSelectRows = (arr) => {
  selectIds.value = arr.map(item => item.id);
};
</script>

<style scoped>
.dialog-footer {
  display: flex;
  justify-content: flex-end;
  gap: 12px;
}
</style>